/*****************************************************************

	ActiveUI 0.2.2 - cross-browser DHTML widgets toolkit.
	Copyright (C) 2003 ActiveUI Software Ltd. All Rights Reserved. 
	More information at http://www.activeui.net/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************/

Active.Text.Table = Active.HTTP.Request.subclass();

Active.Text.Table.create = function(){

/****************************************************************

	Documentation for this module is not yet available.

*****************************************************************/

	var obj = this.prototype;
	var _super = this.superclass.prototype;

	obj.setProperty("responseType", "");

	// -------------------------------------------------------------------------

	obj.response = function(text){
		var i, s, table = [], a = text.split(/\r*\n/);

		var pattern = new RegExp("(^|\\t|,)(\"*|'*)(.*?)\\2(?=,|\\t|$)", "g");

		for (i=0; i<a.length; i++) {
			s = a[i].replace(/""/g, "'");
			s = s.replace(pattern, "$3\t");
			s = s.replace(/\t$/, "");
			if (s) {table[i] = s.split(/\t/)}
		}

		this._data = table;
		_super.response.call(this);
	};

	obj._data = [[""]];

	// -------------------------------------------------------------------------

	obj.getCount = function(){
		return this._data.length;
	};

	obj.getIndex = function(i){
		return i;
	};

	obj.getText = function(i, j){
		return this._data[i][j];
	};

	obj.getImage = function(){
		return "none";
	};

	obj.getValue = function(i, j){
		return this.getText(i, j);
	};
};

Active.Text.Table.create();